package cn.com.tenlion.systembase.util.fullsync;

import cn.com.tenlion.systembase.pojo.dtos.comprehensivecenter.ComprehensiveCenterDTO;
import cn.com.tenlion.systembase.pojo.vos.comprehensivecenter.ComprehensiveCenterVO;
import cn.com.tenlion.systembase.service.comprehensivecenter.IComprehensiveCenterService;
import com.alibaba.fastjson.JSONObject;
import ink.wgink.exceptions.SearchException;
import org.apache.kafka.clients.consumer.ConsumerRecord;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationEventPublisher;
import org.springframework.context.ApplicationEventPublisherAware;
import org.springframework.kafka.annotation.KafkaListener;
import org.springframework.kafka.core.KafkaTemplate;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 表单全量数据同步
 * 接收数据整合系统发来的全量数据同步命令, 向数据整合系统发送表单的全部数据
 */
@Component
public class FullSyncC0010 implements ApplicationEventPublisherAware {

    private ApplicationEventPublisher applicationEventPublisher;
    @Autowired
    private IComprehensiveCenterService comprehensiveCenterService;

    @Autowired
    KafkaTemplate kafkaTemplate;

    public FullSyncC0010() {}

    @KafkaListener(topics = "C0010FullSync")
    public void message(ConsumerRecord<?, ?> record) {
        System.out.println("收到全量同步命令");
        JSONObject jsonObject = JSONObject.parseObject(record.value().toString());
        System.out.println(jsonObject.toJSONString());// 表单编号
        System.out.println(jsonObject.getString("tableNumber"));// 表单编号
        System.out.println(jsonObject.getInteger("tableDataCount"));// 整合系统数据量
        /**
         * 1 . 查询本地数据的数量 , 如果本地数据量 > 整合系统数据量
         * 2 . 查询数据库中所有的事件列表
         * 3 . 遍历事件, 封装数据
         * 4 . 发送新增案件消息
         */
        Map<String, Object> params = new HashMap<>();
        List<ComprehensiveCenterDTO> comprehensiveCenterDTOList = comprehensiveCenterService.list(params);
        System.out.println(comprehensiveCenterDTOList.size());
        if(null != comprehensiveCenterDTOList && comprehensiveCenterDTOList.size() > 0) {
            for(ComprehensiveCenterDTO comprehensiveCenterDTO: comprehensiveCenterDTOList) {
                ComprehensiveCenterVO comprehensiveCenterVO = setData(comprehensiveCenterDTO);
                comprehensiveCenterService.saveKafka(comprehensiveCenterDTO.getComprehensiveCenterId(), comprehensiveCenterVO);
            }
        }
    }

    @KafkaListener(topics = "C0032")
    public void messageMsg(ConsumerRecord<?, ?> record) {
        JSONObject jsonObject = JSONObject.parseObject(record.value().toString());
        Map<String, Object> params = new HashMap<>();
        if(!"delete".equals(jsonObject.getString("action"))) {
            ComprehensiveCenterDTO comprehensiveCenterDTO = comprehensiveCenterService.get(jsonObject.getString("uid"));
            ComprehensiveCenterVO comprehensiveCenterVO = setData(comprehensiveCenterDTO);
            comprehensiveCenterService.saveKafka(comprehensiveCenterDTO.getComprehensiveCenterId(), comprehensiveCenterVO);
        }else {
            comprehensiveCenterService.deleteKafka(jsonObject.getString("uid"));
        }
    }

    private ComprehensiveCenterVO setData(ComprehensiveCenterDTO comprehensiveCenterDTO) {
        if(null == comprehensiveCenterDTO) {
            throw new SearchException("当前对象为空,请注意查看");
        }
        ComprehensiveCenterVO comprehensiveCenterVO = new ComprehensiveCenterVO();
        comprehensiveCenterVO.setCenterName(comprehensiveCenterDTO.getCenterName());
        comprehensiveCenterVO.setCenterLevelName(comprehensiveCenterDTO.getCenterLevelName());
        comprehensiveCenterVO.setCenterLevelCode(comprehensiveCenterDTO.getCenterLevelCode());
        comprehensiveCenterVO.setAddress(comprehensiveCenterDTO.getAddress());
        comprehensiveCenterVO.setLocationCode(comprehensiveCenterDTO.getLocationCode());
        comprehensiveCenterVO.setLongitude(comprehensiveCenterDTO.getLongitude());
        comprehensiveCenterVO.setLatitude(comprehensiveCenterDTO.getLatitude());
        comprehensiveCenterVO.setGrid(comprehensiveCenterDTO.getGrid());
        return comprehensiveCenterVO;
    }

    @Override
    public void setApplicationEventPublisher(ApplicationEventPublisher applicationEventPublisher) {
        this.applicationEventPublisher = applicationEventPublisher;
    }

}